{BareBones driver for Parallax LCD}
CON                                 'Belonging to main
        _clkmode = xtal1 + pll16x   'Standard clock mode * crystal frequency = 80 MHz
        _xinfreq = 5_000_000

'**************************These constants begins the Parallax Serial LCD Display
   BLOn = 17, BLOff = 18        'backlight controls
   FF = 12                      'clear screen
   COffNB = 22                  'cursor off, no blink
   COffB = 23                   'cursor off, blink
   Line0 = 128, Line1 = 148, Line2 = 168, Line3 = 188  'set cursor to beginning of line                      
   SerOut = 17                  'the pin
   Baud = 19200                 'baud rate

VAR                      'these variables belong to the parallax serial LCD
  long  SerBitTime              'clocks in a serial bit time
  long  SerializerCnt           'used to time bits
  word  CharPoint               'used for strings   
  byte  Ascii, BitCnt  
  word  setspec
pub StartDisplay                               'start up the Parallax 4 x 20 display
    outa[Serout]~~                             'serial output to display
    dira[SerOut]~~                             'is an output
    SerBitTime := clkfreq/Baud                 'number of clocks in one bit time
    SerialChar(FF)
    waitcnt(clkfreq/10 + cnt)                 'wait for it to clear
    SerialChar(COffNB)                         'cursor off, no blink
    SerialChar(BlOn)
    TextString(string("Hello, LCD"))
    SpecChars                             'initialize sharp and flat

PUB TextString(TextPoint)       'put a string of text on display at current cursor
    CharPoint := TextPoint
    repeat
        Ascii := byte[CharPoint] 
        if (Ascii ==0) or (Ascii == $A) or (Ascii == $D) 
           return                   'end of string
        SerialChar(Ascii)          'onto display
        CharPoint ++                'on to next character

Pub SerialChar(TheByte)             'Serialize one character
    SerializerCnt := cnt            'initialize timing 
    outa[SerOut]~                    'start bit
    waitcnt(SerializerCnt+=SerBitTime)    'wait for start bit to complete
    repeat 8                        'going to do eight data bits
       outa[SerOut] := TheByte & %1    'set the bit to zero or one
       TheByte := TheByte >> 1         'align the next bit
       waitcnt(SerializerCnt+=SerBitTime)  'one bit time (Pretty much dead on)     '
    outa[SerOut]~~                     'stop bit
    waitcnt(SerializerCnt+=SerBitTime)   'one last bit time

PUB  Disp2Dec(Value)                    'display input value as two decimal characters
     SerialChar((Value/10)+"0")
     SerialChar((Value//10)+"0")

PUB  Disp3Dec(Value)
     SerialChar((Value/100)+"0")        'display hundreds
     Disp2Dec(Value//100)               'then 10s and units

PUB  Disp4Dec(Value)
     SerialChar((Value/1000)+"0")        'display hundreds
     Disp3Dec(Value//1000)               'then 10s and units

PUB  Disp2Hex(Value)
     SerialChar((Value>>4) + "0")
     SerialChar((Value & $F) + "0")

PUB  SpecChars
     serialchar(248)            'spec char 0 is sharp
     serialchar(%01010)
     serialchar(%01010)
     serialchar(%11111)
     serialchar(%01010)
     serialchar(%01010)
     serialchar(%11111)
     serialchar(%01010)
     serialchar(%00000)
     serialchar(249)            'spec char 1 is flat
     serialchar(%10000)
     serialchar(%10000)
     serialchar(%11100)
     serialchar(%10010)
     serialchar(%10001)
     serialchar(%10010)
     serialchar(%11100)
     serialchar(%00000)           
       